<script setup>
import { storeToRefs } from "pinia";
import { RouterLink } from "vue-router";
import BaseButton from "@/components/BaseButton.vue";
import BaseInput from "@/components/BaseInput.vue";
import FloatingSelect from "@/components/FloatingSelect.vue";
import { useInfoStore, MIN_LENGTH, MAX_LENGTH } from "@/stores/Info";
import { useSessionStore } from "@/stores/Session";

const infoStore = useInfoStore();
const sessionStore = useSessionStore();

const { createSession } = sessionStore;

const { creating, deckSelectOptions, deckOption } = storeToRefs(sessionStore);
const { nickname, nameIsInvalid } = storeToRefs(infoStore);

const attemptSessionCreate = async () => {
  try {
    createSession();
  } catch (e) {
    console.error(e);
  }
};
</script>

<template>
  <div>
    <h5 class="card-header">Create a session</h5>
    <div class="card-body">
      <h5 class="card-title fw-bold">
        Create a new session for others to join.
      </h5>
      <div class="card-text row g-2">
        <div class="col-12 text-muted">
          Upon creation, you will be the moderator of the session.
        </div>
        <div class="col-12">
          <BaseInput
            v-model="nickname"
            label="Nickname"
            :min-length="MIN_LENGTH"
            :max-length="MAX_LENGTH"
          />
        </div>
        <div class="col-12">
          <FloatingSelect
            v-model="deckOption"
            :options="deckSelectOptions"
            label="Deck Type"
          />
        </div>
        <div class="col-12 d-grid d-md-flex justify-content-md-end">
          <BaseButton
            :disabled="nameIsInvalid"
            variant="success"
            :loading="creating"
            @click="attemptSessionCreate"
          >
            Create
          </BaseButton>
        </div>
      </div>
      <div class="card-text text-muted d-flex">
        Looking to join instead?&nbsp;<RouterLink to="/join">Join</RouterLink>
      </div>
    </div>
  </div>
</template>
